import usb.core
import usb.util
import sys,time,string,struct,os,socket,threading,traceback

class Picker():
	def __init__(self):
		self.calculator = False
		self.s = False
		self.socketBuffer = ''
		self.id = ''
		self.hub = ''
		self.host = ''
		self.server = 'gcnhub.cemetech.net'
		self.port = 4295
		self.connectedToServer = False
	def parseTokens(self,s):
		s = s.replace("\xbb\xb0","a")
		s = s.replace("\xbb\xb1","b")
		s = s.replace("\xbb\xb2","c")
		s = s.replace("\xbb\xb3","d")
		s = s.replace("\xbb\xb4","e")
		s = s.replace("\xbb\xb5","f")
		s = s.replace("\xbb\xb6","g")
		s = s.replace("\xbb\xb7","h")
		s = s.replace("\xbb\xb8","i")
		s = s.replace("\xbb\xb9","j")
		s = s.replace("\xbb\xba","k")
		s = s.replace("\xbb\xbc","l")
		s = s.replace("\xbb\xbd","m")
		s = s.replace("\xbb\xbe","n")
		s = s.replace("\xbb\xbf","o")
		s = s.replace("\xbb\xc0","p")
		s = s.replace("\xbb\xc1","q")
		s = s.replace("\xbb\xc2","r")
		s = s.replace("\xbb\xc3","s")
		s = s.replace("\xbb\xc4","t")
		s = s.replace("\xbb\xc5","u")
		s = s.replace("\xbb\xc6","v")
		s = s.replace("\xbb\xc7","w")
		s = s.replace("\xbb\xc8","x")
		s = s.replace("\xbb\xc9","y")
		s = s.replace("\xbb\xca","z")
		s = s.replace("\xbb\xd2","#")
		s = s.replace(":",".")
		return s
	def tokenize(self,s):
		s = s.replace('a','\xbb\xb0')
		s = s.replace('b','\xbb\xb1')
		s = s.replace('c','\xbb\xb2')
		s = s.replace('d','\xbb\xb3')
		s = s.replace('e','\xbb\xb4')
		s = s.replace('f','\xbb\xb5')
		s = s.replace('g','\xbb\xb6')
		s = s.replace('h','\xbb\xb7')
		s = s.replace('i','\xbb\xb8')
		s = s.replace('j','\xbb\xb9')
		s = s.replace('k','\xbb\xba')
		s = s.replace('l','\xbb\xbc')
		s = s.replace('m','\xbb\xbd')
		s = s.replace('n','\xbb\xbe')
		s = s.replace('o','\xbb\xbf')
		s = s.replace('p','\xbb\xc0')
		s = s.replace('q','\xbb\xc1')
		s = s.replace('r','\xbb\xc2')
		s = s.replace('s','\xbb\xc3')
		s = s.replace('t','\xbb\xc4')
		s = s.replace('u','\xbb\xc5')
		s = s.replace('v','\xbb\xc6')
		s = s.replace('w','\xbb\xc7')
		s = s.replace('x','\xbb\xc8')
		s = s.replace('y','\xbb\xc9')
		s = s.replace('z','\xbb\xca')
		s = s.replace('#','\xbb\xd2')
		s = s.replace('.',':')
		return s
	def sendMsgToCalc(self,message):
		message = struct.pack("<H",len(message))+message
		message = "\x04"+message
		message="\x00\x00\x00\x00\x00\xFF\xFF\xFF\xFF\xFF"+struct.pack("<H",len(message))+message
		self.calculator.write(0x02,message,0)
	def doSocket(self,line):
		if self.id!='' and not line[5:10] in self.knownIds:
			self.knownIds.append(line[5:10])
			
			self.sendToServer('c',''.join(c.encode('hex') for c in self.id).upper())
			
		print '(S-C) >> Recieved from server '+':'.join('{0:x}'.format(ord(c)) for c in line)
		print '(S-C) << Sending to calculator '+':'.join('{0:x}'.format(ord(c)) for c in line[5:-1])+' ',
		tries = 0
		while tries < 100:
			try:
				self.calculator.write(0x02,line[5:-1],0)
				break
			except usb.core.USBError as e:
				print 'retrying ',
				self.connectCalc()
				tries += 1
				continue
		else:
			print 'Failed'
			return False
		print 'Done'
		return True
	def joinServer(self):
		try:
			if self.connectedToServer:
				self.partServer()
			self.s = socket.socket()
			self.s.settimeout(0.5)
			self.s.connect((self.server,self.port))
			self.connectedToServer = True
			
			if self.id != '':
				self.sendToServer('j',chr(len(self.hub))+self.hub+chr(len(self.host))+self.host)
				self.sendToServer('c',''.join(c.encode('hex') for c in self.id).upper())
			return True
		except:
			return False
	def partServer(self):
		if self.connectedToServer:
			self.s.close()
			self.connectedToServer = False
			print 'Disconnected from server'
			
	def doLine(self,line):
		global s
		print "(C-S) >> Recieved Line from calculator "+":".join("{0:x}".format(ord(c)) for c in line)
		
		addr1 = line[0:5]
		addr2 = line[5:10]
		self.id = addr2
		stuff=line[15:]
		if stuff=='GCNPING':
			self.partServer()
			self.sendMsgToCalc('PONG')
		elif stuff=='GCNUP':
			if self.connectedToServer:
				self.sendMsgToCalc('Y')
			else:
				self.sendMsgToCalc('N')
		elif stuff=='GCNHUB':
			self.sendMsgToCalc(self.tokenize(self.hub))
		elif stuff=='GCNHOST':
			self.sendMsgToCalc(self.tokenize(self.host))
		elif stuff=='GCNSERVER':
			self.sendMsgToCalc(self.tokenize(self.server))
		elif stuff=='GCNPORT':
			self.sendMsgToCalc(self.tokenize(str(self.port)))
		elif stuff[:6]=='GCNSET':
			try:
				params = string.split(line,'\x80')
				
				self.hub = self.parseTokens(params[1])
				self.host = self.parseTokens(params[2])
				self.server = self.parseTokens(params[3])
				self.port = int(self.parseTokens(params[4]))
				print 'Hub:',self.hub
				print 'Host:',self.host
				print 'Server:',self.server
				print 'Port:',self.port
				
				if self.joinServer():
					self.sendMsgToCalc('SUCCESS')
				else:
					self.sendMsgToCalc('FAIL')
			except:
				traceback.print_exc()
				self.sendMsgToCalc('FAIL')
		elif stuff=='GCNPART':
			self.partServer()
		elif self.connectedToServer:
			print 'yaaaay'
			if self.id == '':
				self.id = addr2
				self.sendToServer('j',chr(len(self.hub))+self.hub+chr(len(self.host))+self.host)
				self.sendToServer('c',''.join(c.encode('hex') for c in self.id).upper())
				
			if addr1=="\x00\x00\x00\x00\x00":
				frameType = 'b'
			else:
				frameType = 'f'
			
			
			temp = "\xFF\x89"+line+"*"
			temp = struct.pack("<H",len(temp))+frameType+temp
			print "(C-S) << Sending to server "+":".join("{0:x}".format(ord(c)) for c in temp)+" ",
			self.s.sendall(temp)
			print "Done"
	def checkSocket(self):
		try:
			data = self.s.recv(500)
			self.socketBuffer=self.socketBuffer+data
			while True:
				if len(self.socketBuffer)<3:
					break
				length=ord(self.socketBuffer[0])+256*ord(self.socketBuffer[1])
				if len(self.socketBuffer)<length+3:
					break
				if self.socketBuffer[2]=="b" or self.socketBuffer[2]=="f":
					self.doSocket(self.socketBuffer[:3+length])
				self.socketBuffer = self.socketBuffer[3+length:]
		except socket.timeout:
			return
		except usb.core.USBError as e:
			print 'usb error'
			print e
			traceback.print_exc()
		except Exception as inst:
			print inst
			traceback.print_exc()
	def connectCalc(self):
		tries = 0
		while tries<100:
			try:
				self.calculator = usb.core.find(idVendor=0x0451, idProduct=0xE003)
				if self.calculator is None:
					self.calculator = usb.core.find(idVendor=0x0451, idProduct=0xE008)
					if self.calculator is None:
						time.sleep(0.01)
						tries += 1
						continue
				self.calculator.set_configuration()
				#if self.calculator.is_kernel_driver_active(0) is True:
				#	print "detaching kernel drivers"
				#	self.calculator.detach_kernel_driver(0)
			except usb.core.USBError as e:
				time.sleep(0.01)
				tries += 1
				continue
			break
		else:
			return False
		
		return True
	def sendToServer(self,type,message):
		if type=='c':
			print 'Sending c message'
		self.s.sendall(struct.pack('<H',len(message))+type+message)
	def start(self):
		while True:
			if self.connectCalc():
				print 'Found Calculator'
			else:
				print 'No Calculator found'
				time.sleep(4)
				continue
			
			
			readbuffer = ''
			self.knownIds = []
			while True:
				try:
					data = self.calculator.read(0x81,500)
					if data:
						readbuffer += ''.join([chr(x) for x in data])
						while True:
							if len(readbuffer)<12:
								readbuffer = ''
								break
							length=ord(readbuffer[10])+256*ord(readbuffer[11])
							if len(readbuffer)<length+12:
								break
							self.doLine(readbuffer[:12+length])
							readbuffer = readbuffer[12+length:]
					if self.connectedToServer:
						self.checkSocket()
				except usb.core.USBError as e:
					if e.args[0] == 'Operation timed out' or e == 'Operation timed out':
						if self.connectedToServer:
							self.checkSocket()
						continue
					elif e.args[0] == 'Pipe error' or e.args[0] == 'Resource busy':
						print e.args[0]
						#traceback.print_exc()
						print 'Reconnecting calc'
						if not self.connectCalc():
							break
						continue
					elif e.args[0] == 'Operation timed out':
						print 'timeout'
						traceback.print_exc()
						continue
					elif e.args[0] == 'Input/output error':
						if not self.connectCalc():
							traceback.print_exc()
							break
						continue
					elif e.args[0] == 'No such device (it may have been disconnected)':
						print 'most stupid error EVER'
						if not self.connectCalc():
							traceback.print_exc()
							break
						data = self.calculator.read(0x81,500)
						if data:
							readbuffer += ''.join([chr(x) for x in data])
						continue
					else:
						if not self.connectCalc():
							print 'misc'
							print e.args
							traceback.print_exc()
							break
						continue
				except:
					traceback.print_exc()
					break
			self.partServer()
gcn = Picker()
gcn.start()
